QCAT - User Story #843

ID for single cases and version: Rethinking concerning usability and robustness
17 Mar 2016 11:13 - Kurt Gerber

Status: Closed Start date: 07 Apr 2016
Priority: High Due date: 29 Apr 2016
Assignee: Lukas Vonlanthen % Done: 100%
Category: Estimated time: 0.00 hour
Target version: QCAT Core for UNCCD Testing Spent time: 0.00 hour
Resolution:

Description

We have two different ID's:$

e ID, which identifies a practice case (either approach, or technology)
¢ D to identify a single version of a case.

We use different types of ID's:

¢ Postgres SERIAL:

o Advantage:

o Postgres can handle it perfectly

o Uniqueness is handled automatically by db

o user readible because it is a single number.

o Disadvantage:
The ID ist generated in Postgres through an INSERT statement
Problematic when data is generated in external or offline applications
Only robust in single application setups.

e}

(e}

(o]

e WOCAT code
o Advantage:
o Human readable
o different information condensed in one code (Country, config, number)
o Disadvantage:
o Code has to be generated in the application after a database query looking at existing cases. The workflow is: query ->
code generation -> insert in database
o Thus not very robust in multi user situations
o Code is generated when questionnaire is written in the database. This could be a problem on long edit sessions.
o Problematic when data is generated in external or offline applications

e UUID
o Advantage:
Very robust and approved, when cases are generated in distributed applications
o UUID can be generated on any application layer: client side, server side application, db
o Disadvantage:
o Not really usable for human interaction (too long).
o Therefore can only be used 'in behind the scenes': Backend, API, ...
Subtasks:
Task # 870: Definition of ID rules Closed

History

#1 - 17 Mar 2016 11:19 - Kurt Gerber
- Target version changed from QCAT v0.8 - First Beta to QCAT v0.9 - Second Beta

#2 - 07 Apr 2016 10:38 - Kurt Gerber
- Tracker changed from Task to User Story
- Target version changed from QCAT v0.9 - Second Beta to WOCAT core productive release

- Start date changed from 31 Mar 2016 to 07 Apr 2016
#3 - 19 Apr 2016 10:17 - Kurt Gerber
- Target version changed from WOCAT core productive release to QCAT Core for UNCCD Testing

Solution

e UUID will be used for the identification of single cases (single questionnaire case)
Additionally a human readable code (code) to identify a single case has to be generated.
The code will be generated when a case is inserted in the database.

The code will be used for routing to a sepcific single case

The UUID is authoritative over the code...

#4 - 19 May 2016 10:19 - Lukas Vonlanthen

- Status changed from New to Feedback

#5 - 02 Jun 2016 16:32 - Lukas Vonlanthen
- Status changed from Feedback to Closed

Task 870 was done by commit https:/github.com/CDE-UNIBE/qcat/commit/919d74852d166ef4c41709b382957d988e38cb52, therefore closing user
story.
